<!-- Spinner -->
<ngx-spinner [name]='"workloads"' [fullScreen]="true" bdColor="#f5f5f583" size="medium" type="ball-fussion" color="#EDAE49"></ngx-spinner>

<!-- Navbar -->
<app-navbar></app-navbar>

<!-- Workload Monitoring -->
<div class="card" style="padding: 2%">
    <!-- Title -->
    <mat-label style="display: flex; justify-content: center; margin-top: 4%">
        <mat-icon style="margin-right: 9px">monitor</mat-icon>
        <h1>Registered Workloads</h1>
    </mat-label>

    <!-- Search -->
    <mat-form-field appearance="outline" style="margin-left: 2%; margin-right: 2%">
        <mat-label>Search...</mat-label>
        <input matInput (keyup)="applySearch($event)" placeholder="Search Workloads..." #input />
    </mat-form-field>

    <!-- Create Workload Button -->
    <div class="row">
        <div class="col-lg-22">
            <button mat-raised-button id="create_button" class="btn-2"
                type="button" (click)="createWorkload()">
                <span class="indicator-label">
                <a> Create Workload </a>
                </span>
            </button>
        </div>
    </div>

    <!-- CRUD Table -->
    <mat-table [dataSource]="workloadsTable" matSort #sort_workloads="matSort" matSortActive="id" matSortDirection="desc" matSortDisableClear
    class="mat-elevation-z8">
        <ng-container matColumnDef="id">
            <mat-header-cell class="cells" mat-header-cell *matHeaderCellDef mat-sort-header> ID </mat-header-cell>
            <mat-cell class="cells" mat-cell *matCellDef="let element"> {{ element.id }} </mat-cell>
        </ng-container>

        <ng-container matColumnDef="name">
            <mat-header-cell class="cells" mat-header-cell *matHeaderCellDef mat-sort-header> Workload Name </mat-header-cell>
            <mat-cell class="cells" mat-cell *matCellDef="let element"> {{ element.name }} </mat-cell>
        </ng-container>

        <ng-container matColumnDef="version">
            <mat-header-cell class="cells" mat-header-cell *matHeaderCellDef mat-sort-header> Version </mat-header-cell>
            <mat-cell class="cells" mat-cell *matCellDef="let element"> {{ element.version }} </mat-cell>
        </ng-container>

        <ng-container matColumnDef="ingress_support">
            <mat-header-cell class="cells" mat-header-cell *matHeaderCellDef mat-sort-header> Ingress Support </mat-header-cell>
            <mat-cell class="cells" mat-cell *matCellDef="let element" [ngSwitch]="element.ingress_support">
                <mat-icon *ngSwitchCase="true" style="color: red;"> circle </mat-icon>
                <mat-icon *ngSwitchCase="false" style="color: green;"> circle </mat-icon>
                <!-- {{ element.ingress_support }} -->
            </mat-cell>
        </ng-container>

        <ng-container matColumnDef="status">
            <mat-header-cell class="cells" mat-header-cell *matHeaderCellDef mat-sort-header> Status </mat-header-cell>
            <mat-cell class="cells" mat-cell *matCellDef="let element" [ngSwitch]="element.status">
                <mat-chip *ngSwitchCase="'pending'" [removable]="false" class="status-chip" id="pending">{{ element.status }}</mat-chip>
                <mat-chip *ngSwitchCase="'onboarding'" [removable]="false" class="status-chip" id="onboarding">{{ element.status }}</mat-chip>
                <mat-chip *ngSwitchCase="'accepted'" [removable]="false" class="status-chip" id="accepted">{{ element.status }}</mat-chip>
                <mat-chip *ngSwitchCase="'rejected'" [removable]="false" class="status-chip" id="rejected">{{ element.status }}</mat-chip>
            </mat-cell>
        </ng-container>

        <ng-container matColumnDef="user">
            <mat-header-cell class="cells" mat-header-cell *matHeaderCellDef mat-sort-header> User </mat-header-cell>
            <mat-cell class="cells" mat-cell *matCellDef="let element"> {{ element.user.username }} </mat-cell>
        </ng-container>

        <ng-container matColumnDef="balance">
            <mat-header-cell class="cells" mat-header-cell *matHeaderCellDef mat-sort-header> Balance </mat-header-cell>
            <mat-cell class="cells" mat-cell *matCellDef="let element"> {{ element.balance }} </mat-cell>
        </ng-container>  

        <ng-container matColumnDef="actions">
            <mat-header-cell class="cells" mat-header-cell *matHeaderCellDef mat-sort-header> Actions </mat-header-cell>
            <mat-cell class="cells" mat-cell *matCellDef="let element">
                <!-- Upload Document Button -->
                <input hidden type="file" #chart_uploader (change)="UploadWorkloadDocument($event, element.name, element.version)"/>
                <button mat-icon-button color="primary" (click)="chart_uploader.click()" [disabled]="element.chart"
                matTooltip="Upload Chart File" matTooltipPosition="above">
                    <mat-icon> drive_folder_upload </mat-icon>
                </button>
                <!-- Render Workload -->
                <button mat-icon-button color="primary" (click)="RenderWorkload(element)" [disabled]="element.status !== 'accepted'"
                matTooltip="Create an Instance" matTooltipPosition="above">
                    <mat-icon> play_circle_outline </mat-icon>
                </button>
                <!-- Delete Workload -->
                <button mat-icon-button (click)="DeleteWorkload(element.id)" color="warn" [disabled]="element.status === 'accepted'"
                matTooltip="Delete the Workload" matTooltipPosition="above">
                    <mat-icon>delete</mat-icon>
                </button>
                <!-- Associated Instances -->
                <button mat-icon-button color="primary" (click)="associatedInstances(element.id)"
                matTooltip="Associated Instances" matTooltipPosition="above">
                    <mat-icon> table </mat-icon>
                </button>
                
            </mat-cell>
        </ng-container>

        <mat-header-row *matHeaderRowDef="displayedColumns"></mat-header-row>
        <tr class="mat-row" *matNoDataRow>
            <td class="mat-cell" colspan="4">No Data</td>
        </tr>
        <mat-row matRipple *matRowDef="let row; columns: displayedColumns"
        [class.green]="row.treatmentGroup == 'Intervention'" [class.red]="row.treatmentGroup == 'Control'"
        [class.netrual]="row.treatmentGroup == 'text something e.g null'"></mat-row>
    </mat-table>
    <mat-paginator #paginator_workloads="matPaginator" [pageSizeOptions]="[10, 25, 100]" aria-label="Select page of users"></mat-paginator>
</div>
